(* Driver de la agenda doblemente enlazada.
   SE RECOMIENDA BUSCAR LA SIMPLIFICACION EL EL EXAMEN.
   NO ES ESTE EL CASO. *)

MODULE Dagenda;

FROM IO IMPORT WrLn, WrStr, RdStr, RdChar, KeyPressed;
FROM Window IMPORT Clear;
FROM Agenda IMPORT AGENDA, Crear, Insertar, Consultar, Borrar, Destruir,
                           Modificar, Listar, BorrarAgenda;
FROM MiStr IMPORT CADENA;

PROCEDURE Menu();
BEGIN
    WrStr(" Agenda a ti disposicion  :-) ");WrLn;
    WrStr("            -------------------------------- ");WrLn;
    WrStr("             A.- Crear una agenda. ");WrLn;
    WrStr("             B.- Introducir un registro.");WrLn;
    WrStr("             C.- Consultar un registro.");WrLn;
    WrStr("             D.- Listar la agenda.    ");WrLn;
    WrStr("             E.- Modificar un registro.");WrLn;
    WrStr("             F.- Borrar un registro.");WrLn;
    WrStr("             G.- Borrar la agenda (sin destruirla) ");WrLn;
    WrStr("             H.- Destruir la agenda.");WrLn;
    WrStr("             I.- Salir.");WrLn;
    WrStr("            -------------------------------- ");WrLn;
    WrStr("   Elija una opcion: ");
END Menu;

(* PROCEDIMIENTO DE CHEQUEO DEL ERROR *)
PROCEDURE VerError(error:BOOLEAN);
BEGIN
    WrLn;
    IF error=TRUE THEN
       WrStr(" ERROR!!!. O no has creado la estructura, o esta vacia,");
       WrLn;
       WrStr("              o el elemento no esta, o no hay memoria disponible, ");
       WrLn;
       WrStr("              o el fichero no existe.");
    ELSE
       WrStr(" No hay errores.");
    END;
END VerError;

PROCEDURE EsValido(telefono:ARRAY OF CHAR):BOOLEAN;
VAR
  i:CARDINAL;
BEGIN
    i:=0;
    WHILE (i<=HIGH(telefono)) AND (telefono[i]<>0C) AND (telefono[i]>='0') AND
          (telefono[i]<='9') DO
          INC(i);
    END;
    RETURN (i>HIGH(telefono)) OR (telefono[i]=0C);

END EsValido;

PROCEDURE OpcionA(VAR agenda:AGENDA; VAR creada:BOOLEAN);
VAR
  error:BOOLEAN;
BEGIN
    error:=FALSE;
    agenda:=Crear(error);
    IF NOT error THEN
       creada:=TRUE;
    END;
    VerError(error);
END OpcionA;

PROCEDURE OpcionB(VAR agenda:AGENDA);
VAR
  error:BOOLEAN;
  nombre, telefono:CADENA;
BEGIN
    error:=FALSE;
    WrLn;
    WrStr(" Nombre:");
    RdStr(nombre);
    WrStr(" Telefono(solo numeros):");
    REPEAT
         RdStr(telefono);
    UNTIL EsValido(telefono);
    Insertar(agenda,nombre,telefono,error);
    VerError(error);
END OpcionB;

PROCEDURE OpcionC(VAR agenda:AGENDA);
VAR
  error:BOOLEAN;
  nombre:CADENA;
BEGIN
    error:=FALSE;
    WrLn;
    WrStr(" Nombre: ");
    RdStr(nombre);
    Consultar(agenda,nombre,error);
    VerError(error);
END OpcionC;

PROCEDURE OpcionD(VAR agenda:AGENDA);
VAR
  error:BOOLEAN;
BEGIN
    error:=FALSE;
    Listar(agenda,error);
    VerError(error);
END OpcionD;

PROCEDURE OpcionE(VAR agenda:AGENDA);
VAR
  error:BOOLEAN;
  nombre,telefono:CADENA;
BEGIN
    error:=FALSE;
    WrLn;
    WrStr(" Nombre:");
    RdStr(nombre);
    WrStr(" Nuevo telefono(solo numeros):");
    REPEAT
         RdStr(telefono);
    UNTIL EsValido(telefono);
    Modificar(agenda,nombre,telefono,error);
    VerError(error);
END OpcionE;

PROCEDURE OpcionF(VAR agenda:AGENDA);
VAR
  error:BOOLEAN;
  nombre:CADENA;
BEGIN
    error:=FALSE;
    WrLn;
    WrStr(" Nombre:");
    RdStr(nombre);
    Borrar(agenda,nombre,error);
    VerError(error);
END OpcionF;

PROCEDURE OpcionG(VAR agenda:AGENDA);
VAR error:BOOLEAN;
BEGIN
    BorrarAgenda(agenda,error);
    VerError(error)
END OpcionG;


PROCEDURE OpcionH(VAR agenda:AGENDA; VAR creada:BOOLEAN);

BEGIN
    Destruir(agenda,creada);
    creada:=FALSE;
END OpcionH;

PROCEDURE OpcionI(VAR opcion:CHAR; creada:BOOLEAN);
VAR
  salir:CHAR;
BEGIN
    IF creada THEN
       WrStr(" ATENCION!! Destruye la estructura antes de salir. ");
    ELSE
       WrStr(" Esta seguro de salir(S/N): ");
       REPEAT
            salir:=CAP(RdChar());
       UNTIL (salir='S') OR (salir='N');
       IF salir='S' THEN
          opcion:='S';
       END;
    END;
END OpcionI;

PROCEDURE Ejecutar(VAR agenda:AGENDA; VAR  opcion:CHAR; VAR  creada:BOOLEAN);
BEGIN
    Clear();
    WrLn;
    IF (NOT creada) AND (opcion<>'A') AND (opcion<>'I') THEN
       WrStr(" Error. La estructura no esta creada, utilice la opcion 'A' ");
       WrLn;
       WrStr(" para crearla o la opcion 'H' para salir. ");
    ELSIF creada AND (opcion='A') THEN (** No puedo volver a crear la agenda**)
          WrStr(" La agenda ya esta creada. ");
    ELSIF creada AND (opcion='I') THEN (** No puedo salir sin destruir la agenda**)
          WrStr(" Destruya la agenda antes de salir. ");
    ELSE

       CASE opcion OF
         'A':OpcionA(agenda,creada) |
         'B':OpcionB(agenda) |
         'C':OpcionC(agenda) |
         'D':OpcionD(agenda) |
         'E':OpcionE(agenda) |
         'F':OpcionF(agenda) |
         'G':OpcionG(agenda) |
         'H':OpcionH(agenda,creada) |
         'I':OpcionI(opcion,creada)
      END;
    END;
END Ejecutar;

PROCEDURE Pausa();
VAR
  pausa:CHAR;
BEGIN
    WrLn;
    WrStr("               Pulse una tecla para continuar: ");
    REPEAT UNTIL KeyPressed();
END Pausa;

PROCEDURE Main();
VAR
  agenda:AGENDA;
  opcion:CHAR;
  creada:BOOLEAN;
BEGIN
    creada:=FALSE;
    REPEAT
              Clear();
              Menu();
              REPEAT
                   opcion:=CAP(RdChar());
              UNTIL (opcion>='A') AND (opcion<='I');
              Ejecutar(agenda,opcion,creada);
              Pausa();
    UNTIL opcion='S';
    Clear();
    WrLn;WrLn;WrLn;
    WrStr("   *** Gracias por usar este software ***  ");
END Main;


BEGIN
    Main();
END Dagenda.


